#!/usr/bin/env bash

_parse_options ()
{
    command=${1:-}
    shift

    for i in "$@"
    do
        case $i in
            -h|--help)
                _show_help
                exit 0
            ;;
            --opt=*)
                opt_opt="${i#*=}"
                shift
            ;;
        esac
    done
}

_show_help ()
{
    echo
    echo 'Usage:	./run.sh COMMAND [OPTIONS]'
    echo
}

_loop ()
{
    echo "Starting ..."

    while [ 1 ]; do
        echo "Working ..."
        sleep 1
    done
}

_interactive ()
{
    echo "Starting ..."

    while [ 1 ]; do
        read -p "> " string
        echo "< ${string}"
    done
}

_success ()
{
    echo "Starting ..."
    echo "Stopping ..."
    exit 0
}

_fail ()
{
    echo "Starting ..."
    echo "Failing ..."
    exit 1
}

_main ()
{
    case $command in
        "loop")                         _loop;;
        "success")                      _success;;
        "fail")                         _fail;;
        "interactive")                  _interactive;;
        "help" | "--help" | "-h" | "")  _show_help;;

        *) echo "Invalid command. Add --help option for details" >> /dev/stderr;;
    esac
}

_parse_options "$@"
_main